#pragma once

#include "core/note.h"
#include "initializers/mockarrownoteinitializer.h"

class MockClassicNote : public Note
{
public:

    enum State
    {
          NONE,

        FLYING,
         DYING,
          DEAD
    };

    explicit MockClassicNote(MockArrowNoteInitializer&& init);
    virtual ~MockClassicNote() = default;

    virtual bool isActive() const override final;
    virtual bool isInGame() const override final;
    virtual bool shouldRemove() const override final;

    virtual void putToGame(const microsec &music_offset) override = 0;
    virtual void update(const microsec &music_offset) override = 0;
    virtual void draw() const override = 0;
};
